import * as mc from "@minecraft/server";
import {} from "enchantment.js";

// Dimension constants
const overworld = mc.world.getDimension("overworld")
const nether = mc.world.getDimension("nether")
const the_end = mc.world.getDimension("the_end")

const axeDamage = 4
const botanyTime = 80; // Botany time is in ticks, 20 ticks per second // Lowest you can make this value is 80
// Botany time is the time it takes to update and fill the chest below

const oak_sapling = new mc.ItemStack("minecraft:sapling")

const onTick = () => {

    // Botany Tick
    getBotany(overworld.getEntities({type:"hog:botany"}))
    getBotany(nether.getEntities({type:"hog:botany"}))
    getBotany(the_end.getEntities({type:"hog:botany"}))

    mc.system.run(onTick);
}
onTick();

// If you want to let your saplings from your own addons work
// In your loot tables add a folder named "bonsai"
// Then make a loot table with the name of the item id (the bit after the : )
// Then make the loot of what you want to spawn there


function getBotany(botanys){
    for (const botany of botanys){
        // Finds the item
        var item = botany.getComponent("inventory").container.getItem(0)

        botany.nameTag = "§r§rBotany Pot"

        if (item){
            // Splits the name from the identifier
            var splitItem = item.typeId.split(":")
            var lootTable = splitItem[1]
            
            // WOOOOOOO THEY REMOVED THE DATA FOR SAPLINGS ITS A GOOD DAY
            // That has hindered this code from working this way for so long
            // The code worked just not for some of the vanilla saplings :(

            botanyUpdate(botany,lootTable)
        }
    }
}

function botanyUpdate(botany,lootTable){
    // Set tick
    const tick = botany.getDynamicProperty("tick") > 0 ? botany.getDynamicProperty("tick") : 0;

    // Getting axe
    var axe = botany.getComponent("inventory").container.getItem(1)
    if (axe){
        // Update singular botany tick
        addTick(botany);
        
        // Setting botany speed
        var newBotanyTime = botanyTime
        if (axe.hasComponent("minecraft:enchantable")) if (axe.getComponent("minecraft:enchantable").hasEnchantment("efficiency")){
            newBotanyTime = botanyTime - (15*axe.getComponent("minecraft:enchantable").getEnchantment("efficiency").level)
        }

        // Updates on regular botany time
        if (tick % newBotanyTime === 0){
            if (axe.hasTag("minecraft:is_axe")){
                // Diamond droppings code
                if (axe.getDynamicProperty(`enchant.diamond_droppings.valid`)){
                    if ((Math.random()*400)<axe.getDynamicProperty(`enchant.diamond_droppings.level`)){
                        botany.runCommand(`loot insert ~ ~-0.5 ~ loot "diamond"`)
                    }
                }

                // Spawning loot table
                botany.runCommand(`loot insert ~ ~-0.5 ~ loot "bonsai/${lootTable}"`)

                // Damage axe
                const damage = axe.getComponent("minecraft:durability").damage
                if (!getUnbreakingChance(axe)){
                    if (damage+axeDamage >= axe.getComponent("minecraft:durability").maxDurability){
                        axe = new mc.ItemStack("minecraft:air")
                    }else {
                        axe.getComponent("minecraft:durability").damage += axeDamage;
                    }
                }
                
                botany.getComponent("inventory").container.setItem(1,axe)
            }
        }

        // Updating the arrow
        const arrowInt = Math.floor((tick%newBotanyTime)/(newBotanyTime/23))
        const arrow = new mc.ItemStack(`hog:arrow_${arrowInt}`)
        botany.getComponent("inventory").container.setItem(2,arrow)

        return;
    }
    
    // Showing arrow on first use
    if (!botany.getComponent("inventory").container.getItem(2)){
        const arrow = new mc.ItemStack(`hog:arrow_0`,1)
        botany.getComponent("inventory").container.setItem(2,arrow)
    }
}



function getUnbreakingChance(item){
    if (item.getComponent("minecraft:enchantable").hasEnchantment("unbreaking")){
        const unbreaking = item.getComponent("minecraft:enchantable").getEnchantment("unbreaking")
        const rand = Math.random()*100
        const unbreakingChance = 100/(unbreaking.level+1)

        if (rand < unbreakingChance){
            return false
        }else {
            return true
        }
    }
}


function addTick(entity){
    if (!entity.getDynamicProperty("tick")){
        entity.setDynamicProperty("tick",1)
    }else {
        entity.setDynamicProperty("tick",entity.getDynamicProperty("tick")+1)
    }
}
